<refentry id="lang-reference" revision="25 December 2006">
<refmeta>
<refentrytitle>Language Definition v2.0 Reference</refentrytitle>
</refmeta>

<refnamediv>
<refname>Language Definition v2.0 Reference</refname>
<refpurpose>
Reference to the GtkSourceView language definition file format
</refpurpose>
</refnamediv>

<refsect1>
<title>Overview</title>

<note>
  <para>
    The version 2 here refers to the language definition file format,
    not to the version of GtkSourceView. So this reference is suitable
    for GtkSourceView 2 and 3.
  </para>
</note>

<para>
This is an overview of the Language Definition XML format, describing the
meaning and usage of every element and attribute.  The formal definition is
stored in the RelaxNG schema file <filename>language2.rng</filename> which
should be installed on your system in the directory
<filename>${PREFIX}/share/gtksourceview-3.0/</filename> (where
<filename>${PREFIX}</filename> can be <filename>/usr/</filename> or
<filename>/usr/local/</filename> if you have installed from source.
</para>
</refsect1>

<refsect1>
<title>Tag <code>&lt;language&gt;</code></title>
<para>
The root element for Language Definition files.
</para>

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;metadata&gt;</code> (optional)</member>
<member><code>&lt;styles&gt;</code> (optional)</member>
<member><code>&lt;default-regex-options&gt;</code> (optional)</member>
<member><code>&lt;keyword-char-class&gt;</code> (optional)</member>
<member><code>&lt;definitions&gt;</code> (mandatory)</member>
</simplelist>.
</para>

<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (mandatory)</term>
<listitem><para>
Identifier for the description. This is used for
external references and must be unique among language descriptions. It can
contain a string of letters, digits, hyphens ("<code>-</code>") and
underscores ("<code>_</code>").
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>name</code> (mandatory)</term>
<listitem><para>
The translatable name of the language presented to the user.
It can be marked for translation putting an underscore before the attribute
name (see the gettext documentation).
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>version</code> (mandatory)</term>
<listitem><para>
The version of the XML format (currently "2.0").
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>section</code> (optional)</term>
<listitem><para>
The translatable category in which the language has to be grouped when
presented to the user. It can be marked for translation putting
an underscore before the attribute name. Currently used categories in
GtkSourceView are "Sources", "Scripts",  "Markup" and "Others", but
it is possible to use arbitrary categories (while usually discouraged).
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>hidden</code> (optional)</term>
<listitem><para>
It's a hint that the language should be "hidden" from user. For instance,
def.lang has this flag, and a text editor should not present "default" as
a syntax highlighting choice.
</para></listitem>
</varlistentry>

</variablelist>

</refsect1>

<refsect1>
<title>Tag <code>&lt;metadata&gt;</code></title>

<para>
Contains optional metadata about the language definition.
</para>

<para>
Recognized elements are (all optional):
</para>

<varlistentry>
<term><code>mimetypes</code></term>
<listitem><para>
The semicolon-separated list of mimetypes associated to the language.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>globs</code></term>
<listitem><para>
The semicolon-separated list of globs associated to the language.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>line-comment-start</code></term>
<listitem><para>
String used to create single-line comment in files of this type, e.g.
"#" in shell scripts.
It may be used in an editor to implement Comment/Uncomment functionality.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>block-comment-start</code></term>
<listitem><para>
String used to start block comment in files of this type, e.g. "/*" in C
files.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>block-comment-end</code></term>
<listitem><para>
String used to end block comment in files of this type, e.g. "*/" in C
files.
</para></listitem>
</varlistentry>

</refsect1>

<refsect1>
<title>Tag <code>&lt;styles&gt;</code></title>

<para>
Contains the definitions of every style used in the current language and
their association with predefined styles in GtkSourceView.
</para>

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;style&gt;</code> (one or more)</member>
</simplelist>.
</para>
</refsect1>


<refsect1>
<title>Tag <code>&lt;style&gt;</code></title>

<para>
Defines a style, associating it's id with a user visible translatable
name and a default style.
</para>

<para>
Contained elements: none.
</para>

<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (mandatory)</term>
<listitem><para>
Identifier for the style. This is used in the current language
to refer to this style and must be unique for the current document.
It can contain a string of letters, digits,
hyphens ("<code>-</code>") and underscores ("<code>_</code>").
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>name</code> (mandatory)</term>
<listitem><para>
The user visible translatable name for the style. It has to be preceded
with a underscore ("<code>_</code>") to be marked for translation.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>map-to</code> (optional)</term>
<listitem><para>
Used to map the style with a default style, to use colors and
font properties defined for those default styles.
The id of the default style has to be preceded with the id of the
language where it is defined, separated with a semicolon ":".
When omitted the style is not considered derived from any style and will
be not highlighted until the user specifies a color scheme for this
style.
</para></listitem>
</varlistentry>

</variablelist>
</refsect1>

<refsect1>
<title>Tag <code>&lt;keyword-char-class&gt;</code></title>

<para>
Contains a regex character class used to redefine the customizable
word boundary delimiters "\%[" and "\%]". This class is the set of character
that can be commonly found in a keyword.
If the element is omitted the two delimiters default to "\b".
</para>

<para>
Contained elements: none.
</para>
</refsect1>


<refsect1>
<title>Tag <code>&lt;default-regex-options&gt;</code></title>

<para>
Used to set global options for how regular expressions are processed.
</para>

<para>
Contained elements: none.
</para>

<variablelist>
<title>Attributes</title>
<varlistentry>
<term><code>case-sensitive</code> (optional)</term>
<listitem><para>Set to <code>false</code> to make regular expressions
ignore case.  
Defaults to <code>true</code>.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>extended</code> (optional)</term>
<listitem><para>Setting this to <code>true</code> makes the regular
expression engine ignore spaces and comments. These comments start with
"<code>#</code>" and continue to the end of the line.
Defaults to <code>false</code>.
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>dupnames</code> (optional)</term>
<listitem><para>Setting this to true allows one to repeat an identifier
for capturing parentheses.  This is useful for some patterns that you
know only one instance of a named subpattern can ever be matched.
Defaults to <code>false</code>.
</para></listitem>
</varlistentry>

</variablelist>

<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;definitions&gt;</code></title>

<para>
The element containing the real description of the syntax to be
highlighted. It contains one or more <code>&lt;context&gt;</code> element and an
arbitrary number of <code>&lt;define-regex&gt;</code> elements, interleaved.
It has no attributes.
Every contained element must have its <code>id</code> attribute set to an
identifier unique for the document. Exactly one of the contained
<code>&lt;context&gt;</code> element must have
the <code>id</code> attribute set to the <code>id</code> of the
<code>&lt;language&gt;</code> root element,
representing the initial context for the highlighting, the one the engine
enters at the beginning of the highlighted file.
</para>

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;context&gt;</code> (one or more)</member>
<member><code>&lt;define-regex&gt;</code> (zero or more)</member>
</simplelist>.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;define-regex&gt;</code></title>

<para>
Defines a regular expression that can be reused inside other regular
expression, to avoid replicating common portions.  Those regular
expressions are PCRE regular expressions in the form <code>/regex/options</code> (see
the documentation of PCRE for details). If there are no options to be
specified and you don't need to match the spaces at the start and at the
end of the regular expression, you can omit the slashes, putting here only
<code>regex</code>.  The possible options are those specified above in the description
of the <code>&lt;default-regex-options&gt;</code> element. To disable a group of
options, instead, you have to prepend an hyphen <code>-</code> to them.  In
GtkSourceView are also available some extensions to the standard Perl style
regular expressions:
</para>

<itemizedlist>
<listitem><para>
<code>\%[</code> and <code>\%]</code> are custom word boundaries, which can
be redefined with the <code>&lt;keyword-char-class&gt;</code> (in contrast with
<code>\b</code>);
</para></listitem>

<listitem><para>
<code>\%{id}</code> will include the regular expression defined in another
<code>&lt;define-regex&gt;</code> element with the specified id.
</para></listitem>
</itemizedlist>

<para>
Contained elements: none.
</para>

<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (mandatory)</term>
<listitem><para>
Identifier for the regular expression. This is used
for the inclusion of the defined regular expression and must be unique
for the current document. It can contain a string of letters, digits,
hyphens ("<code>-</code>") and underscores ("<code>_</code>").
</para></listitem>
</varlistentry>
</variablelist>

</refsect1>

<refsect1>
<title>Tag <code>&lt;context&gt;</code></title>

<para>
This is the most important element when describing the syntax: the file to
be highlighted is partitioned in contexts representing the portions to be
colored differently. Contexts can also contain other contexts.
There are different kind of context elements: simple contexts, container
contexts, sub-pattern contexts, reference contexts and keyword contexts.
</para>

<refsect2>
<title>Simple contexts</title>
They contain a mandatory <code>&lt;match&gt;</code> element and an optional
<code>&lt;include&gt;</code> element. The context will span over the strings
matched by the regular expression contained in the <code>&lt;match&gt;</code>
element. In the <code>&lt;include&gt;</code> element you
can only put sub-pattern contexts.

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;match&gt;</code> (mandatory)</member>
</simplelist>.
</para>


<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (optional)</term>
<listitem><para>
A unique identifier for the context, used in references to the context. It
can contain a string of letters, digits, hyphens ("<code>-</code>") and
underscores ("<code>_</code>").
</para></listitem></varlistentry>

<varlistentry>
<term><code>style-ref</code> (optional)</term>
<listitem><para>
Highlighting style for this context. Value of this attribute
may be id of a style defined in current lang file, or id of a style
defined in other files prefixed with corresponding language id,
e.g. "def:comment".
</para></listitem></varlistentry>

<varlistentry>
<term><code>extend-parent</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context has higher
priority than the end of its parent. If not specified it defaults to
<code>true</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>end-parent</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context terminates parent context.
If not specified it defaults to <code>false</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>first-line-only</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context can occur only
on the first line of buffer. If not specified it defaults to <code>false</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>once-only</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context can occur only
once in its parent. If not specified it defaults to <code>false</code>.
</para></listitem></varlistentry>
</variablelist>

</refsect2>

<refsect2>
<title>Container contexts</title>
They contain a <code>&lt;start&gt;</code> element and an optional
<code>&lt;end&gt;</code>. They respectively contain the regular
expression that makes the engine enter in the context and the terminating one.
In the optional <code>&lt;include&gt;</code> element you can put contained
contexts of every type (simple, container, sub-pattern or reference).
If the <code>&lt;start&gt;</code> element is omitted, then the
<code>id</code> attribute and the <code>&lt;include&gt;</code> become
mandatory (the context can only be used as a container to include
its children).

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;start&gt;</code> (optional)</member>
<member><code>&lt;end&gt;</code> (optional)</member>
<member><code>&lt;include&gt;</code> (optional)</member>
</simplelist>.
</para>

<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (mandatory only if <code>&lt;start&gt;</code> not present)</term>
<listitem><para>
A unique identifier for the context, used in references to the context. It
can contain a string of letters, digits, hyphens ("<code>-</code>") and
underscores ("<code>_</code>").
</para></listitem></varlistentry>

<varlistentry>
<term><code>style-ref</code> (optional)</term>
<listitem><para>
Highlighting style for this context. Value of this attribute
may be id of a style defined in current lang file, or id of a style
defined in other files prefixed with corresponding language id,
e.g. "def:comment".
</para></listitem></varlistentry>

<varlistentry>
<term><code>style-inside</code> (optional)</term>
<listitem><para>
If this attribute is "true", then the highlighting style will
be applied to the area between start and end matches; otherwise
whole context will be highlighted.
</para></listitem></varlistentry>

<varlistentry>
<term><code>extend-parent</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context has a higher
priority than the end of he parent. If not specified it defaults to
<code>true</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>end-at-line-end</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context must be forced
to end at the end of the line, displaying an error ???? XXX. If not specified
it defaults to <code>false</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>end-parent</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context terminates parent context
when it ends.
If not specified it defaults to <code>false</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>first-line-only</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context can start only
on the first line of buffer. If not specified it defaults to <code>false</code>.
</para></listitem></varlistentry>

<varlistentry>
<term><code>once-only</code> (optional)</term>
<listitem><para>
A boolean value telling the engine whether the context can occur only
once in its parent. If not specified it defaults to <code>false</code>.
</para></listitem></varlistentry>
</variablelist>
</refsect2>

<refsect2>
<title>Sub-pattern contexts</title>

<para>
They refer to a group in a regular expression of the parent context, so it
is possible to highlight differently only a portion of the matched regular
expression.
</para>

<para>
Contained elements: none.
</para>


<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (optional)</term>
<listitem><para>
A unique identifier for the context. It can contain a string of letters,
digits, hyphens ("<code>-</code>") and underscores ("<code>_</code>").
</para></listitem></varlistentry>

<varlistentry>
<term><code>sub-pattern</code> (mandatory)</term>
<listitem><para>
The sub-pattern to which we refer. "0" means the whole expression, "1" the
first group, "2" the second one, etc. If named sub-patterns are used you can
also use the name.
</para></listitem></varlistentry>

<varlistentry>
<term><code>where</code> (mandatory only in container contexts)</term>
<listitem><para>
Can be "<code>start</code>" or "<code>end</code>". It has to be used
only if the parent is a container context to specify whether the
sub-pattern is in the regular
expression of the <code>&lt;start&gt;</code> or the <code>&lt;end&gt;</code>
element. In simple contexts it must be omitted.
</para></listitem></varlistentry>
</variablelist>

</refsect2>

<refsect2>
<title>Reference contexts</title>

<para>
Used to include a previously defined context.
</para>

<para>
Contained elements: none.
</para>

<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>ref</code> (mandatory)</term>
<listitem><para>
The id of the context to be included. A colon followed by an asterisk
("<code>:*</code>") at the end of the id means that the parent should include
every children of the specified context, instead of the context itself.
Prepending the id of another language to the id of the context (separated
with a semicolon ":") is possible to include contexts defined inside such
external language.
</para></listitem></varlistentry>

<varlistentry>
<term><code>style-ref</code> (optional)</term>
<listitem><para>
Style in included context may be overridden by using this attribute.
Its value is id of the style to be used instead of style specified
in the referenced context.
</para></listitem></varlistentry>

<varlistentry>
<term><code>ignore-style</code> (optional)</term>
<listitem><para>
If this attribute it "true" then the referenced context will not
be highlighted. It does not affect child contexts and their styles.
</para></listitem></varlistentry>
</variablelist>

</refsect2>

<refsect2>
<title>Keyword contexts</title>
<para>
They contain a list of <code>&lt;keyword&gt;</code> and matches every keyword
listed. You can also put a <code>&lt;prefix&gt;</code> and/or a
<code>&lt;suffix&gt;</code> common to every keyword.
</para>
<para>
Note that keywords are matched in the order they are listed, so if you
have both a keyword "foo" and a keyword "foobar", you should always list
foobar before foo, or it will never be matched.
</para>

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;prefix&gt;</code> (optional)</member>
<member><code>&lt;suffix&gt;</code> (optional)</member>
<member><code>&lt;keyword&gt;</code> (one or more)</member>
</simplelist>.
</para>

<para>
The attributes are the same used in simple contexts.
</para>

</refsect2>
</refsect1>

<refsect1>
<title>Tag <code>&lt;include&gt;</code></title>

<para>
Contains the list of context contained in the current
<code>&lt;context&gt;</code>.
</para>

<para>
Contained elements:
<simplelist type="inline">
<member><code>&lt;context&gt;</code> (one or more)</member>
<member><code>&lt;define-regex&gt;</code> (zero or more)</member>
</simplelist>.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;match&gt;</code></title>

<para>
Contains the regular expression for the current simple context. 
The expression is in the same form used in
<code>&lt;define-regex&gt;</code> elements.
It is allowed to use any of the attributes from 
<code>&lt;default-regex-opts&gt;</code> as attributes of this tag.
</para>

<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;start&gt;</code></title>

<para>
Contains the starting regular expression for the current container context.
The expression is in the same form used in <code>&lt;define-regex&gt;</code>
elements.
It is allowed to use any of the attributes from 
<code>&lt;default-regex-opts&gt;</code> as attributes of this tag.
</para>

<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;end&gt;</code></title>

<para>
Contains the terminating regular expression for the current container
context. The expression is in the same form used in <code>&lt;define-regex&gt;</code>
elements, with an extension: <code>\%{sub-pattern@start}</code> will be
substituted with the string matched in the corresponding sub-pattern
(can be a number or a name if named sub-patterns are used) in the
preceding <code>&lt;start&gt;</code> element. For instance you could
implement shell-style here-documents with this code:
</para>

<programlisting>
&lt;context id="here-doc"&gt;
    &lt;start&gt;&amp;lt;&amp;lt;\s*(\S+)$&lt;/start&gt;
    &lt;end&gt;^\%{1@start}$&lt;/end&gt;
&lt;/context&gt;
</programlisting>

<para>
It is also possible to use any of the attributes from 
<code>&lt;default-regex-opts&gt;</code> as attributes of this tag.
</para>
<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;keyword&gt;</code></title>

<para>
Contains a keyword to be matched by the current context. The keyword is a
regular expression in the form used in <code>&lt;define-regex&gt;</code>.
</para>

<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;prefix&gt;</code></title>

<para>
Contains a prefix common to all of the following keywords in the current
context. The prefix is a regular expression in the form used in
<code>&lt;define-regex&gt;</code>. If not specified it defaults to
<code>\%[</code>
</para>

<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;suffix&gt;</code></title>

<para>
Contains a suffix common to all of the following keywords in the current
context. The suffix is a regular expression in the form used in
<code>&lt;define-regex&gt;</code>. If not specified it defaults to
<code>\%]</code>
</para>

<para>
Contained elements: none.
</para>

</refsect1>

<refsect1>
<title>Tag <code>&lt;replace&gt;</code></title>

<para>
The replace tag allows you to change one context so it functions as 
another context.  For example, in the <code>html.lang</code> definition, 
there are a few references to a null context with id 
"<code>external</code>".  In <code>php.lang</code>, that context is 
replaced like this: <code>&lt;replace id="html:external" 
ref="php-block"&gt;</code>, so that php blocks are recognized within the 
<code>html:html</code> context at the points where the 
<code>external</code> context appears.
</para>

<para>
Contained elements: none.
</para>

<variablelist>
<title>Attributes:</title>

<varlistentry>
<term><code>id</code> (mandatory)</term>
<listitem><para>
The id of the context to replace. Ex: <code>id="html:external"</code>
</para></listitem>
</varlistentry>

<varlistentry>
<term><code>ref</code> (mandatory)</term>
<listitem><para>
The id of the context to put in place of the context being replaced. Ex: <code>ref="php-block"</code>
</para></listitem>
</varlistentry>

</variablelist>

</refsect1>
 
</refentry>
